VERSION 5.00
Begin VB.Form frmSave 
   Caption         =   "Save Query as a Condition"
   ClientHeight    =   4470
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6060
   LinkTopic       =   "Form2"
   ScaleHeight     =   4470
   ScaleWidth      =   6060
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboCategory 
      Height          =   315
      Left            =   1200
      TabIndex        =   2
      Top             =   2400
      Width           =   3855
   End
   Begin VB.TextBox txtDescription 
      Height          =   375
      Left            =   1200
      TabIndex        =   3
      Top             =   2880
      Width           =   4455
   End
   Begin VB.TextBox txtName 
      Height          =   375
      Left            =   1200
      TabIndex        =   1
      Top             =   1920
      Width           =   3855
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   375
      Left            =   1200
      TabIndex        =   4
      Top             =   3480
      Width           =   975
   End
   Begin VB.CommandButton cmdAbort 
      Caption         =   "Abort"
      Height          =   375
      Left            =   3600
      TabIndex        =   5
      Top             =   3480
      Width           =   975
   End
   Begin VB.ListBox lstQuery 
      Height          =   1425
      Left            =   1200
      MouseIcon       =   "HiSave.frx":0000
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   360
      Width           =   3855
   End
   Begin VB.Label lblWait 
      Caption         =   "Updating Indices, please wait ..."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   375
      Left            =   840
      TabIndex        =   10
      Top             =   3960
      Width           =   3735
   End
   Begin VB.Label Label4 
      Caption         =   "Category :  "
      Height          =   375
      Left            =   360
      TabIndex        =   9
      Top             =   2400
      Width           =   855
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Description :  "
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   2880
      Width           =   1095
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Name :  "
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   1920
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Query :  "
      Height          =   375
      Left            =   0
      TabIndex        =   6
      Top             =   600
      Width           =   1215
   End
End
Attribute VB_Name = "frmSave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim cname As String ' new name for condition
Private Sub Form_Activate()
    Dim i As Integer
    lblWait.Visible = False
    txtName = ""
    txtDescription = ""
    ' load lstQUery as a read-only copy of the query
    lstQuery.Clear
    For i = 0 To frmHiMain!lstQuery.ListCount - 1
        lstQuery.AddItem frmHiMain!lstQuery.List(i)
    Next
    ' load cboCategory as a copy of the cboCategory on frmHiMain
    cboCategory.Clear
    For i = 0 To frmHiMain!cboCategory.ListCount - 1
        cboCategory.AddItem frmHiMain!cboCategory.List(i)
    Next i
    cmdSave.Tag = 0 ' flag for successful save
    txtName.SetFocus
    lstQuery.MousePointer = 99
End Sub
Private Sub lstQuery_Click()
    If quiet Then Exit Sub
    MsgBox "You cannot edit the query here, please abort and go back to the main screen"
    txtName.SetFocus
End Sub
Private Sub txtName_GotFocus()
    ' if user clicked on lstQuery they get an error, but it remains selected
    ' this code turns off that selection
    quiet = True
    If lstQuery.ListIndex > -1 Then lstQuery.Selected(lstQuery.ListIndex) = False
    quiet = False
End Sub
Private Sub txtName_LostFocus()
    Dim i As Integer, msg As String, ok As Integer, reserved As String
    
    cname = txtName.text
    
    ' Check not a reserved word
    reserved = "[EXISTS],[OTHER],..."
    If InStr(reserved, "[" & UCase(cname) & "]") Then
        msg = "That is a Reserved Word.  Please choose another Name"
        ok = MsgBox(msg, vbOKCancel, "Save Query as a Condition")
            Select Case ok
            Case vbCancel
                cmdAbort_Click
            Case vbOK
                txtName.SetFocus
            End Select
        Exit Sub
    End If
    
    ' Check that name does not contain ']&' - parser gets confused
    If InStr(cname, "]&") Then
        msg = "Names are not allowed to contain the string ']&'.  Please choose another name"
        ok = MsgBox(msg, vbOKCancel, "Save Query as a Condition")
            Select Case ok
            Case vbCancel
                cmdAbort_Click
            Case vbOK
                txtName.SetFocus
            End Select
        Exit Sub
    End If
    
    ' Check that this is not already in use
    For i = 1 To frmHiMain!lstCondition.ListCount - 1
        If UCase(frmHiMain!lstCondition.List(i)) = UCase(cname) Then
            msg = "There is already another condition with that Name"
            ok = MsgBox(msg, , "Save Query as a Condition")
            txtName.SetFocus
            Exit Sub
        End If
    Next

End Sub
Private Sub cmdSave_Click()
    Dim sc As String, category As String, msg As String, ok As Integer

    cname = txtName.text
    If cname = "" Then
        msg = "You cannot save a query without giving it a name"
        ok = MsgBox(msg, , "Save Query as a Condition")
        txtName.SetFocus
        Exit Sub
    End If
    
    ' set up the new condition
    category = cboCategory
    lblWait.Visible = True
    DoEvents
    sc = Condition.Add(HiClass, "Compound", SendQuery, cname, cname, category, txtDescription.text, 1)
    
    cmdSave.Tag = 1 ' flag successful save to the calling module
    lblWait.Visible = False
    DoEvents
    frmSave.Hide

End Sub
Private Sub cmdAbort_Click()
    cmdSave.Tag = 0
    frmSave.Hide
End Sub
