Attribute VB_Name = "LoadComboBox"
Option Explicit
Public Sub LoadCombo(Factory As Object, _
                        cboCombo As ComboBox, _
                        MyClass As String, _
                        MyQuery As String, _
                        DescCol As Integer, _
                        Optional MaxCount As Integer, _
                        Optional ShowFirst As Boolean, _
                        Optional param1 As String, _
                        Optional param2 As String, _
                        Optional param3 As String, _
                        Optional param4 As String, _
                        Optional param5 As String, _
                        Optional param6 As String, _
                        Optional param7 As String, _
                        Optional param8 As String, _
                        Optional param9 As String)
    ' general-purpose sub to load a combobox from a query
    ' Parameters :
    '   Factory - a connected CacheObject Factory object
    '   cboCombo - a combobox
    '   MyClass - a Cache Object class name
    '   MyQuery - a query within MyClass
    '     If this query does not contain a (numeric) ID,
    '     then Itemdata will not be loaded
    '   DescCol - the column number (GetData) to be loaded
    '   MaxCount - the maximum number of entries to load
    '   ShowFirst - whether to show the first entry in the combo
    '   Param1-9 - optional query parameter values
    
    Dim result As cacheobject.ResultSet
    If MyClass = "" Then Exit Sub
    If MyQuery = "" Then Exit Sub

    Set result = Factory.ResultSet(MyClass, MyQuery)
    result.Execute param1, param2, param3, param4, param5, param6, param7, param8, param9
    
    Dim IdCol As Integer
    IdCol = result.ContainsID
    
    Dim max As Long
    If MaxCount = 0 Then
        max = 999999
    Else
        max = MaxCount
    End If
    
    Dim id As String
    cboCombo.Clear
    While result.Next And cboCombo.ListCount <= max
        cboCombo.AddItem result.GetData(DescCol)
        If IdCol Then
            id = result.GetData(IdCol)
            If IsNumeric(id) Then cboCombo.ItemData(cboCombo.NewIndex) = id
        End If
    Wend
    
    result.Close
    If ShowFirst And (cboCombo.ListCount > 0) Then
        cboCombo.ListIndex = 0
    End If

End Sub
